/*
 * Copyright (c) 2014 The Linux Foundation. All rights reserved.
 *
 * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
 *
 *
 * Permission to use, copy, modify, and/or distribute this software for
 * any purpose with or without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
 * AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * This file was originally distributed by Qualcomm Atheros, Inc.
 * under proprietary terms before Copyright ownership was assigned
 * to the Linux Foundation.
 */

/*===========================================================================
 *
 *  @file:     wlan_types.h
 *
 *  @brief:    This file defines the common types for wlan
 *
 *  @author:   Xiaochang Duan
 *
 *
 *=========================================================================*/

#ifndef __WLAN_TYPES_H__
#define __WLAN_TYPES_H__

/*-------------------------------------------------------------------------
  Include Files
-------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------
 * Preprocessor Definitions and Constants
 * -------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------
 *  Type Declarations
 * -------------------------------------------------------------------------*/

typedef uint32_t   uint32;      /* Unsigned 32 bit value */

typedef uint16_t   uint16;      /* Unsigned 16 bit value */

typedef uint8_t    uint8;       /* Unsigned 8  bit value */

typedef int32_t    int32;       /* Signed 32 bit value */

typedef int16_t    int16;       /* Signed 16 bit value */

typedef int8_t     int8;        /* Signed 8  bit value */

typedef int64_t    int64;       /* Signed 64 bit value */

typedef uint64_t   uint64;      /* Unsigned 64 bit value */

typedef uint8_t    byte;        /* byte type */

typedef uint8_t    boolean;     /* Boolean Type */

#endif //__WLAN_TYPES_H__
