/*
 * Copyright (c) 2014, 2018 The Linux Foundation. All rights reserved.
 *
 * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
 *
 *
 * Permission to use, copy, modify, and/or distribute this software for
 * any purpose with or without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
 * AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * This file was originally distributed by Qualcomm Atheros, Inc.
 * under proprietary terms before Copyright ownership was assigned
 * to the Linux Foundation.
 */

#if !defined( __I_VOS_LIST_H )
#define __I_VOS_LIST_H

/**=========================================================================

  \file  i_vos_list.h

  \brief Linux-specific definitions for vOSS lists

  ========================================================================*/

/* $Header$ */

/*--------------------------------------------------------------------------
  Include Files
  ------------------------------------------------------------------------*/
#include <vos_types.h>
#include <vos_status.h>
#include <vos_packet.h>
#include <linux/list.h>
#include <linux/mutex.h>
#include <linux/kernel.h>

/*--------------------------------------------------------------------------
  Preprocessor definitions and constants
  ------------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
/*--------------------------------------------------------------------------
  Type declarations
  ------------------------------------------------------------------------*/
typedef struct vos_linux_list_s
{
   struct list_head anchor;
   v_SIZE_t count;
   struct mutex lock;
   v_U32_t cookie;
} vos_list_t;

typedef struct list_head vos_list_node_t;


#ifdef __cplusplus
}
#endif /* __cplusplus */

#define __VOS_LIST_NODE_INIT(prev_node, next_node) \
	{ .prev = &(prev_node), .next = &(next_node), }
#define __VOS_LIST_NODE_INIT_SINGLE(node) \
	__VOS_LIST_NODE_INIT(node, node)
#define __VOS_LIST_ANCHOR(list) ((list).anchor)

#endif // __I_VOS_LIST_H
